<?php
class ReCopyWidget extends CWidget {

    /**
     * @var string images path of this widget
     */
    public $targetClass='clone';
    public $addButtonLabel='Add more';
    public $addButtonCssClass='';
    public $removeButtonLabel='Remove';
    public $removeButtonCssClass='recopy-remove';
    
    private $_assetsUrl;

    /**
     * Initializes the widgets
     */
    public function init() {
        parent::init();
        if ($this->_assetsUrl === null) {
            $assetsDir = dirname(__FILE__) . DIRECTORY_SEPARATOR . 'assets';
            $this->_assetsUrl = Yii::app()->assetManager->publish($assetsDir);
        }
    }

    /**
     * Execute the widgets
     */
    public function run() {
        Yii::app()->clientScript
            ->registerScriptFile($this->_assetsUrl . '/reCopy.js', CClientScript::POS_HEAD)
            ->registerScript(__CLASS__, '
                $(function(){
                    var removeLink = \' <a class="'.$this->removeButtonCssClass.'" href="#" onclick="$(this).parent().slideUp(function(){ $(this).remove() }); return false">'.$this->removeButtonLabel.'</a>\';
                    $("a.recopy-add").relCopy({ append: removeLink});	
                });
            ', CClientScript::POS_HEAD);
        
        echo CHtml::link($this->addButtonLabel, '#', array('rel'=>'.'.$this->targetClass, 'class'=>implode(' ', array_filter(array('recopy-add', $this->addButtonCssClass)))));
    }
}//end class